set ArmCount 0    ; # counter
set ArmFlg   0    ; # True then Arming progress.
set ArmTimer 50   ; # timer interval .
#################
# Angle count
#################
set ArmTbl {
    {1 20}
    {-4 2}
    {4 1}
    {-4 1}
    {4 2}
    {-4 2}
    {4 2}
    {-4 3}
}

proc Do_Arming {obj ev seq} {
    global ArmCount vsContinue vsStop vsCSLocal vsRelative vsPeriodicTask
    global vsTclScript vsCSWorld vsAbsolute
    global ArmFlg ArmTbl ArmTimer
    global x y z rx1 ry1 rz1 rx2 ry2 rz2 rx3 ry3 rz3

    incr ArmCount
    if {$ArmCount > [lindex [lindex $ArmTbl $seq] 1]} {
	if {$seq < [llength $ArmTbl]} {
	    vsRotateAngle $obj 0.0 [lindex [lindex $ArmTbl $seq] 0] \
		    0.0 $vsCSLocal $vsRelative
	    incr seq
	    set ArmCount 0 
	    vsAddTimeOutHandler $obj $ArmTimer $vsTclScript \
		    "" Do_Arming $seq $vsPeriodicTask

	    return $vsStop
	} else {
	    set ArmFlg 0
	    set ArmCount 0 
	    vsRotate $obj $rx1 $ry1 $rz1 $rx2 $ry2 $rz2 $rx3 $ry3 $rz3 \
		    $vsCSWorld $vsAbsolute
	    return $vsStop
	}
    } else {
        vsRotateAngle $obj 0.0 [lindex [lindex $ArmTbl $seq] 0] \
		0.0 $vsCSLocal $vsRelative
    }
    return $vsContinue
}

proc Arming {obj ev user} {
    global vsTclScript vsPeriodicTask
    global ArmFlg ArmTimer vsFalse
    global x y z rx1 ry1 rz1 rx2 ry2 rz2 rx3 ry3 rz3

    if {!$ArmFlg} {
        vsPlaySpotSoundByName arm $vsFalse
	vsGetObjWRT $obj x y z rx1 ry1 rz1 rx2 ry2 rz2 rx3 ry3 rz3
	vsAddTimeOutHandler $obj $ArmTimer $vsTclScript \
		"" Do_Arming 0 $vsPeriodicTask
	set ArmFlg 1
    }
}
